package com.siemag.testng;

import static org.testng.AssertJUnit.*;

import javax.naming.InitialContext;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;
import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.arquillian.testng.Arquillian;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.testng.annotations.AfterClass;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.Test;

import com.siemag.test.utils.AbstractTestMaster;
import com.siemag.test.utils.AbstractTestMasterLocal;
import com.siemag.test.utils.ArquillianTestUtil;
import com.siemag.utils.Groups;

@Test(groups = Groups.GR1)
public class AssertTestARQWithoutParent extends Arquillian {

  static {
    BasicConfigurator.configure();
  }

  private Logger                                    log = Logger.getLogger(getClass());
  @Deployment
  public static JavaArchive createArchiveTest(){
    JavaArchive ear = ArquillianTestUtil.getSimpleTestArchive(
        AssertTestARQWithoutParent.class, AbstractTestMasterLocal.class, AbstractTestMaster.class);
    System.err.println("DEPLOYMENT COMPLETE");
    return ear;

  }

  @BeforeClass
  public void start(){
    if (isRunningInContainer()) {
      fail("FAKE FAIL");
    }
  }

  @AfterClass
  public void stop(){
    if (isRunningInContainer()) {
      fail("FAKE FAIL");
    }
  }

  @Test(dependsOnMethods = "c")
  public void a(){
    System.out.println("ExceptionInBeforeTestWMS.a()");
    assertTrue(true);
  }

  @Test
  public void b(){
    System.out.println("ExceptionInBeforeTestWMS.b()");
    assertTrue(false);
  }

  @Test
  public void c(){
    System.out.println("ExceptionInBeforeTestWMS.c()");
    assertTrue(false);
  }

  public final boolean isRunningInContainer(){
    return isServer();
  }

  public synchronized boolean isServer(){
    Object service = null;
    try {
      /* ****************************************************************************   */
      /* The service java:/ConnectionFactory is standardized in the JEE6 specification  */
      /* and is deployed before any application.                                        */
      /* So we get a reference for this lookup then we are running in server            */
      /* ****************************************************************************   */

      InitialContext ictx = new InitialContext();
      service = ictx.lookup("java:/ConnectionFactory");
    } catch (Exception e) {
      return false;
      // IGNORE
    }

    return service != null;
  }
  
}
