package com.siemag.test.utils;

import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.asset.EmptyAsset;
import org.jboss.shrinkwrap.api.spec.JavaArchive;

/**
 * Helperclass for deploy Testcases in an EJB Container.
 * @author vuru
 *
 */
public class ArquillianTestUtil {

  /**
   * Lookup String for Usertranaction. You can use @Resource(mappedName=ArquillianTestUtil.LOOKUP_USERTRANSACTION) for injection.
   */
  public static final String LOOKUP_USERTRANSACTION = "java:jboss/UserTransaction";

  

  /**
   * Create a simple deployable jar file withthe give classes
   * @param jarName
   * @param withBeansXML
   * @param additionalClasses
   * @return
   */
  public static JavaArchive getSimpleTestArchive( Class<?>... additionalClasses){
    return getJarArchive(null,true,additionalClasses);
  }
  
  private static JavaArchive getJarArchive(String jarName, boolean withBeansXML, Class<?>... additionalClasses){
    JavaArchive jarArch = null;
    try {
      if (isNullOrEmpty(jarName)){
        jarArch = ShrinkWrap.create(JavaArchive.class).addClasses(additionalClasses);
      }else{
        jarArch = ShrinkWrap.create(JavaArchive.class, jarName).addClasses(additionalClasses);
      }
      if (withBeansXML) {
        jarArch = jarArch.addAsResource(EmptyAsset.INSTANCE, "beans.xml");
      }
    } catch (IllegalArgumentException e) {
      e.printStackTrace();
    }
    return jarArch;
  }

  private static boolean isNullOrEmpty(String value){
    return value == null || value.trim().length()==0;
  }
 
}
