package com.siemag.utils;

import org.testng.ITestResult;
import org.testng.TestListenerAdapter;

public class ConsoleStatusTestListener extends TestListenerAdapter {

  
  @Override
  public void onTestFailure(ITestResult tr){
    super.onTestFailure(tr);
    log(tr);
  }
  
  @Override
  public void onTestSkipped(ITestResult tr){
    super.onTestSkipped(tr);
    log(tr);
  }
  
  @Override
  public void onTestStart(ITestResult tr){
    super.onTestStart(tr);
    log(tr);
  }
  
  @Override
  public void onTestSuccess(ITestResult tr){
    super.onTestSuccess(tr);
    log(tr);
  }
  
  @Override
  public void onTestFailedButWithinSuccessPercentage(ITestResult tr){
    super.onTestFailedButWithinSuccessPercentage(tr);
    log(tr);
  }
  
  private void log(ITestResult tr) {
    System.out.println(getStatus(tr) +" "+tr.getInstanceName() +"."+tr.getMethod().getMethodName()+"()");
  }
  
  private String getStatus(ITestResult tr){
    String result = null;
    
    switch (tr.getStatus()) {
      case ITestResult.FAILURE:
        result = "FAILURE";
        break;
      case ITestResult.SKIP:
        result = "SKIP";
        break;
      case ITestResult.STARTED:
        result = "STARTED";
        break;
      case ITestResult.SUCCESS:
        long runtime = tr.getEndMillis() -tr.getStartMillis();
        result = "FINISHED in "+runtime+" [ms]";
        break;
      case ITestResult.SUCCESS_PERCENTAGE_FAILURE:
        result = "SUCCESS_PERCENTAGE_FAILURE";
        break;
       default :
         result = "UNKOWN";
    }
    return "[ "+result+" ]";
  }
}
