package com.siemag.utils;

import java.util.LinkedList;
import java.util.List;
import java.util.SortedMap;
import java.util.TreeMap;

import org.testng.IMethodInstance;
import org.testng.IMethodInterceptor;
import org.testng.ITestContext;
import org.testng.annotations.Test;

public class Groupsorter implements IMethodInterceptor {

  private SortedMap<String, LinkedList<IMethodInstance>> methodCache = new TreeMap<>();
  
  @Override
  public List<IMethodInstance> intercept(List<IMethodInstance> methods, ITestContext context){

    for (int i = 0; i < methods.size(); i++) {
      IMethodInstance method = methods.get(i);
      String groupName = getGroupName(method.getInstance().getClass());
      cacheMethod(groupName, method);
//      System.err.println(method.getInstance().getClass() + " " + getGroupName(method.getInstance().getClass()));
    }
    
//    LinkedList<IMethodInstance> result = new LinkedList<>();
//    for(String group:methodCache.keySet() ){
//      result.addAll(methodCache.get(group));
//    }
//    
//    for(IMethodInstance sorted :result ){
//      System.err.println(sorted.getMethod().getGroups()[0] +" "+sorted.getInstance().getClass()+" "+sorted.getMethod().getMethodName());
//    }
    return methods;
  }

  private void cacheMethod(String groupName, IMethodInstance method){
    LinkedList<IMethodInstance> methods = methodCache.get(groupName);
    if(methods == null ){
      methods = new LinkedList<>();
    }
    methods.add(method);
    methodCache.put(groupName, methods);
  }
  private String getGroupName(Class<?> clazz){

    if (Object.class.equals(clazz)) {
      return null;
    }

    if (clazz.isAnnotationPresent(Test.class)) {
      Test annotation = clazz.getAnnotation(Test.class);
      String[] groups = annotation.groups();
      if (groups.length != 1) {
        throw new RuntimeException("A TestClass can have only one group");
      }
      return groups[0];
    } else {
      return getGroupName(clazz.getSuperclass());
    }
  }

}
